c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine check_sizes(Nb,Nq,nspecies)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'

      integer Nb,Nq,Nk,nspecies,nlay
      double precision sdksidT,sdksidx,sdnerdx
      double precision tsdksidT,tsdksidx,tsdnerdx
      parameter(sdksidT=632.0D+0*1024D+0/83/1088) ! kb/k/layer
      parameter(sdksidx=335.0D+0*1024D+0/83/1088) ! kb/k/layer
      parameter(sdnerdx=1.1D+0*1024.0D+0*1024D+0/83/1088) ! kb/k/layer

      Nk=Nb*Nq
      nlay=m+2
      
      tsdksidT=sdksidT*nlay*Nk/1024.0D+0 ! Mb
      tsdksidx=sdksidx*nlay*Nk/1024.0D+0 ! Mb
      tsdnerdx=sdnerdx*nlay*Nk/1024.0D+0 ! Mb

      if ((calc_dNERdTp.eq.1).and.(s_dksidT.eq.1)) then
         call screen(1501,0,0,tsdksidT,0.0D+0)
      endif
      if ((calc_dNERdx.eq.1).and.(s_dksidx.eq.1)) then
         call screen(1502,0,0,tsdksidx,0.0D+0)
      endif
      if ((calc_dNERdx.eq.1).and.(s_dNERdx.eq.1)) then
         call screen(1503,0,0,tsdnerdx,0.0D+0)
      endif
      
      return
      end
