c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine choice_freq(md,sens,Nb,Nq,nb_pdfh,cumul_pdfh,nb_pdfb,
     &     cumul_pdfb,opth,optb,w,band,quad)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'freq.inc'

      integer Nb,Nq,band,quad,md,sens
      double precision w,w_b,w_g

c     Le but de cette routine est de calculer band et quad, resp. le numro
c     de la longueur d'onde [1..Nb]  laquelle se droule le calcul
c     monochromatique, et le numro du gaz virtuel choisi pour le calcul.
c     
c     Entres :
c       + sens : sens=0 : tir vers le bas ; sens=1 : tir vers le haut
c       + md : numro de la maille d'mission [0..m+1]
c       + Nb : nombre de bandes troites
c       + Nq : ordre de la quadrature
c       + nb_pdf : tableau des pdf de pondration des bandes troites pour chaque maille
c       + cumul_pdf : tableau des cumules des pdf de pondration des bandes troites
c
c     Sorties :
c       + band : numro de la bande choisie [1..Nb]
c       + quad : numro du gaz de quadrature choisi [1..Nq]
c       + w : poids associ au choix de la bande et du gaz
c       + out : 1: tout s'est bien pass
c               0: erreur dans l'excution; le programme doit tre arrt
c

      call pdf_freq(md,sens,Nb,Nq,nb_pdfh,cumul_pdfh,nb_pdfb,cumul_pdfb,
     &     opth,optb,w,band,quad)

      return
      end
