c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine postcalc(Nb,Nq)

      implicit none

c     Routine de post-traitement : calcul et sauvegarde de tous les rsultats

      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      include 'options.inc'
      include 'tab.inc'
      include 'files_out.inc'
      include 'formats.inc'

      integer i,j,k,nk,Nb,Nq,band,quad,raf1,raf2,indp,indq,indt,out,mr
      integer sec
      double precision Planck
      double precision sum_bil(0:Nmax),sum2_bil(0:Nmax)
      double precision sum_bil_gs(0:Nmax),sum2_bil_gs(0:Nmax)
      double precision sum_bil_ge(0:Nmax),sum2_bil_ge(0:Nmax)
      double precision sum_bil_gp(0:Nmax),sum2_bil_gp(0:Nmax)
      double precision sum_bil_gg(0:Nmax),sum2_bil_gg(0:Nmax)
      double precision sum_tbil(0:Nmax),sum2_tbil(0:Nmax)
      double precision sum_bil_rev(0:Nmax)
      double precision sum2_bil_rev(0:Nmax)
      double precision sum_tbil_rev(0:Nmax),sum2_tbil_rev(0:Nmax),s1,s2
      double precision psi(0:Nmax),inc_psi(0:Nmax)
      double precision best_psi(0:Nmax)
      double precision inc_best_psi(0:Nmax)
      double precision psi_gg(1:Nmax),inc_psi_gg(1:Nmax)
      double precision psi_gp(1:Nmax),inc_psi_gp(1:Nmax)
      double precision psi_gs(1:Nmax),inc_psi_gs(1:Nmax)
      double precision psi_ge(1:Nmax),inc_psi_ge(1:Nmax)
      double precision var_psi_gs(1:Nmax)
      double precision var_psi_ge(1:Nmax)
      double precision var_psi_gp(1:Nmax)
      double precision var_psi_gg(1:Nmax)
      double precision sum_bil_se,sum2_bil_se
      double precision psi_se,inc_psi_se,var_psi_se
      double precision psi_seb,inc_psi_seb
      double precision psi_rev(0:Nmax),inc_psi_rev(0:Nmax)
      double precision sigmac,sigmad2,psic,psid,tmp1,tmp3,tmp4
      double precision l_moy(0:Nmax),inc_l_moy(0:Nmax)
      double precision sum_tpne(0:Nmax+1,0:Nmax+1)
      double precision sum2_tpne(0:Nmax+1,0:Nmax+1)
      double precision tPNE(0:Nmax+1,0:Nmax+1)
      double precision rtPNE(0:Nmax+1,0:Nmax+1)
      double precision var_tPNE(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNE(0:Nmax+1,0:Nmax+1)
      double precision inc_rtPNE(0:Nmax+1,0:Nmax+1)
      double precision tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision rtPNEsym(0:Nmax+1,0:Nmax+1)
      double precision inc_rtPNEsym(0:Nmax+1,0:Nmax+1)
      double precision tpsi(1:Nmax),inc_tpsi(1:Nmax)
      double precision rtpsi(1:Nmax),inc_rtpsi(1:Nmax)
      double precision tpsi_rev(1:Nmax),inc_tpsi_rev(1:Nmax)
      double precision tpsih(1:Nmax),inc_tpsih(1:Nmax)
      double precision tpsib(1:Nmax),inc_tpsib(1:Nmax)
      double precision z,sum,sum2
      double precision var_psi(0:Nmax)
      double precision var_psi_rev(0:Nmax)
      double precision var_tpsi(0:Nmax),var_tpsi_rev(0:Nmax)
      double precision tbil_gg(1:Nmax),inc_tbil_gg(1:Nmax)
      double precision tbil_pg(1:Nmax),inc_tbil_pg(1:Nmax)
      double precision best_bilan(0:Nmax),inc_best_bilan(0:Nmax)
      double precision T,p
      double precision psib(0:Nmax+1),inc_psib(0:Nmax+1)
      double precision psib_gg(0:Nmax+1),inc_psib_gg(0:Nmax+1)
      double precision psib_gp(0:Nmax+1),inc_psib_gp(0:Nmax+1)
      double precision psib_gs(0:Nmax+1),inc_psib_gs(0:Nmax+1)
      double precision psib_ge(0:Nmax+1),inc_psib_ge(0:Nmax+1),nbw,lbw
      double precision rpsib(0:Nmax+1),inc_rpsib(0:Nmax+1)
      double precision rpsib_gg(0:Nmax+1),inc_rpsib_gg(0:Nmax+1)
      double precision rpsib_gp(0:Nmax+1),inc_rpsib_gp(0:Nmax+1)
      double precision rpsib_gs(0:Nmax+1),inc_rpsib_gs(0:Nmax+1)
      double precision rpsib_ge(0:Nmax+1),inc_rpsib_ge(0:Nmax+1)
      double precision sum_pnef(0:Nmax+1,0:Nmax+1)
      double precision sum2_pnef(0:Nmax+1,0:Nmax+1)
      double precision pnef(0:Nmax+1,0:Nmax+1)
      double precision rpnef(0:Nmax+1,0:Nmax+1)
      double precision ksi(0:Nmax+1,0:Nmax+1)
      double precision rksi(0:Nmax+1,0:Nmax+1)
      double precision var_pnef(0:Nmax+1,0:Nmax+1)
      double precision inc_pnef(0:Nmax+1,0:Nmax+1)
      double precision inc_rpnef(0:Nmax+1,0:Nmax+1)
      double precision pnefsym(0:Nmax+1,0:Nmax+1)
      double precision inc_pnefsym(0:Nmax+1,0:Nmax+1)
      double precision T0(0:Nmax+1)
      double precision rT0(0:Nmax+1)
      double precision rtpsi_gs(0:Nmax+1)
      double precision rtpsi_ge(0:Nmax+1)
      double precision rtpsi_gg(0:Nmax+1)
      double precision inc_rtpsi_gs(0:Nmax+1)
      double precision inc_rtpsi_ge(0:Nmax+1)
      double precision inc_rtpsi_gg(0:Nmax+1)

c     Pour les flux
      double precision sum_fasc(0:Nmax+1,0:Nmax+1)
      double precision sum_fdes(0:Nmax+1,0:Nmax+1)
      double precision sum2_fasc(0:Nmax+1,0:Nmax+1)
      double precision sum2_fdes(0:Nmax+1,0:Nmax+1)
      double precision fasc(0:Nmax+1,0:Nmax)
      double precision fdes(0:Nmax+1,0:Nmax)
      double precision var_fasc(0:Nmax+1,0:Nmax)
      double precision var_fdes(0:Nmax+1,0:Nmax)
      double precision inc_fasc(0:Nmax+1,0:Nmax)
      double precision inc_fdes(0:Nmax+1,0:Nmax)
      double precision fasct(0:Nmax)
      double precision fdest(0:Nmax)
      double precision inc_fasct(0:Nmax)
      double precision inc_fdest(0:Nmax)
      double precision fnett(0:Nmax)
      double precision inc_fnett(0:Nmax)
      double precision fnett_pne(0:Nmax)
      double precision inc_fnett_pne(0:Nmax)
      double precision fnetb_pne(0:Nmax)
      double precision inc_fnetb_pne(0:Nmax)
      double precision sum_fa_ang(0:Nmax,1:Nsec_mx)
      double precision sum_fd_ang(0:Nmax,1:Nsec_mx)
      double precision sum2_fa_ang(0:Nmax,1:Nsec_mx)
      double precision sum2_fd_ang(0:Nmax,1:Nsec_mx)
      double precision fa_ang(0:Nmax,1:Nsec_mx)
      double precision fd_ang(0:Nmax,1:Nsec_mx)
      double precision var_fa_ang(0:Nmax,1:Nsec_mx)
      double precision var_fd_ang(0:Nmax,1:Nsec_mx)
      double precision inc_fa_ang(0:Nmax,1:Nsec_mx)
      double precision inc_fd_ang(0:Nmax,1:Nsec_mx)
      double precision sum_faf(0:Nmax)
      double precision sum_fdf(0:Nmax)
      double precision sum2_faf(0:Nmax)
      double precision sum2_fdf(0:Nmax)
      double precision faf(0:Nmax)
      double precision fdf(0:Nmax)
      double precision var_faf(0:Nmax)
      double precision var_fdf(0:Nmax)
      double precision inc_faf(0:Nmax)
      double precision inc_fdf(0:Nmax)
      double precision Fplus0,FplusH,Fmoins0,FmoinsH
c     Debug
c      double precision fat_ang(0:Nmax)
c      double precision fdt_ang(0:Nmax)
c     Debug
c

      nk=Nb*Nq
      out=1

      call screen(11,0,0,0.0D+0,0.0D+0)
      call countd(1,0,0,0.0D+0,out)

      do i=0,m+1
         sum_tbil(i)=0.0D+0
         sum2_tbil(i)=0.0D+0
         sum_tbil_rev(i)=0.0D+0
         sum2_tbil_rev(i)=0.0D+0
         sum_tpne(i,i)=0.0D+0
         sum2_tpne(i,i)=0.0D+0
         tPNE(i,i)=0.0D+0
         tPNEsym(i,i)=0.0D+0
         inc_tPNEsym(i,i)=0.0D+0
         do j=0,m+1
            sum_tpne(i,j)=0.0D+0
            sum2_tpne(i,j)=0.0D+0
         enddo
c     Flux
         do j=0,m
            sum_fasc(i,j)=sum_fasch(i,j)+sum_fascb(i,j)
            sum_fdes(i,j)=sum_fdesh(i,j)+sum_fdesb(i,j)
            sum2_fasc(i,j)=sum2_fasch(i,j)+sum2_fascb(i,j)
            sum2_fdes(i,j)=sum2_fdesh(i,j)+sum2_fdesb(i,j)
         enddo ! j
      enddo ! i

      do i=0,m
         do sec=1,Nsec
c     Debug
c            if (i.eq.m) then
c               write(*,*) theta_sec(sec,1),theta_sec(sec,2),
c     &              sum_fah_ang(i,sec)
c            endif
c     Debug
            sum_fa_ang(i,sec)=sum_fah_ang(i,sec)+sum_fab_ang(i,sec)
            sum_fd_ang(i,sec)=sum_fdh_ang(i,sec)+sum_fdb_ang(i,sec)
            sum2_fa_ang(i,sec)=sum2_fah_ang(i,sec)+sum2_fab_ang(i,sec)
            sum2_fd_ang(i,sec)=sum2_fdh_ang(i,sec)+sum2_fdb_ang(i,sec)
         enddo                  ! sec
      enddo                     ! i
      
      do i=0,m+1
         do j=0,m+1
            sum_tpne(i,j)=sum_PNEh(i,j)+sum_PNEb(i,j)
            sum2_tpne(i,j)=sum2_PNEh(i,j)+sum2_PNEb(i,j)
         enddo
      enddo
            
c
c     +-----------------------------------------------------------------------------------+
c     |                            Calcul des rsultats                                   |
c     +-----------------------------------------------------------------------------------+
c

c     computation of the average temperature of each element
      call calc_T(T0)
      call calc_rT(m-2,rT0)
      indp=1
      open(10,file=file_bil_freq)
      open(11,file=file_inc_bil_freq)
      open(12,file=file_bil_freq_gg)
      open(13,file=file_inc_bil_freq_gg)
      open(14,file=file_bil_freq_gp)
      open(15,file=file_inc_bil_freq_gp)
      open(16,file=file_bil_freq_gs)
      open(17,file=file_inc_bil_freq_gs)
      open(18,file=file_bil_freq_ge)
      open(19,file=file_inc_bil_freq_ge)
      open(20,file='./results/psi_sol_esp.txt')
      open(40,file='./results/rbilans_freq.txt')
      open(41,file='./results/inc_rbilans_freq.txt')
      open(42,file='./results/rbilans_freq_gg.txt')
      open(43,file='./results/inc_rbilans_freq_gg.txt')
      open(44,file='./results/rbilans_freq_gp.txt')
      open(45,file='./results/inc_rbilans_freq_gp.txt')
      open(46,file='./results/rbilans_freq_gs.txt')
      open(47,file='./results/inc_rbilans_freq_gs.txt')
      open(48,file='./results/rbilans_freq_ge.txt')
      open(49,file='./results/inc_rbilans_freq_ge.txt')
c     Fichier de rsultat pour les PNE monochromatiques
      open(21,file=file_pne_mono)
      open(22,file='./results/Flux_nets_mono-nu.txt')
      open(23,file='./results/ksi.txt')
      open(24,file='./results/Flux_asc_mono-nu.txt')
      open(25,file='./results/Flux_des_mono-nu.txt')
      open(31,file='./results/rPNE_mono.txt')
      open(33,file='./results/rksi.txt')
      open(34,file='./results/spectral_transm_refl.txt')
      write(21,*) m,Nb
      write(22,*) m,Nb
      write(23,*) m,Nb
      write(31,*) m-2,Nb
      write(33,*) m-2,Nb
c
      do band=1,Nb            ! dbut boucle sur les bandes
         nbw=no_hi(band)-no_lo(band)
         lbw=lambda_hi(band)-lambda_lo(band)
         do i=0,m+1
            psib(i)=0.0D+0
            inc_psib(i)=0.0D+0
            psib_gg(i)=0.0D+0
            inc_psib_gg(i)=0.0D+0
            psib_gp(i)=0.0D+0
            inc_psib_gp(i)=0.0D+0
            psib_gs(i)=0.0D+0
            inc_psib_gs(i)=0.0D+0
            psib_ge(i)=0.0D+0
            inc_psib_ge(i)=0.0D+0
            if (cpm.eq.1) then
               do j=0,m+1
                  sum_pnef(i,j)=0.0D+0
                  sum2_pnef(i,j)=0.0D+0
               enddo            ! sur j
               do j=0,m
                  sum_faf(j)=0.0D+0
                  sum_fdf(j)=0.0D+0
                  sum2_faf(j)=0.0D+0
                  sum2_fdf(j)=0.0D+0
               enddo
            endif
         enddo ! sur i
         psi_seb=0.0D+0
         inc_psi_seb=0.0D+0

         do quad=1,Nq ! dbut boucle sur les quadratures
c            call signal_handler() ! signal handling
            call numk(Nq,band,quad,k)

            if (cpm.eq.1) then
               do i=0,m+1
                  do j=0,m+1
c                     sum_pnef(i,j)=dble(sum_pnefh(i,j,k))
c     &                    +dble(sum_pnefb(i,j,k))
c                     sum2_pnef(i,j)=dble(sum2_pnefh(i,j,k))
c     &                    +dble(sum2_pnefb(i,j,k))
c     Debug
c                  if ((i.eq.0).and.(j.eq.0)) then
c                     write(*,*) 'sum_pnefh(',k,')=',sum_pnefh(i,j,k)
c                     write(*,*) 'sum_pnefb(',k,')=',sum_pnefb(i,j,k)
c                  endif
c     Debug
                     sum_pnef(i,j)=sum_pnef(i,j)
     &                    +sum_pnefh(i,j,k)
     &                    +sum_pnefb(i,j,k)
                     sum2_pnef(i,j)=sum2_pnef(i,j)
     &                    +sum2_pnefh(i,j,k)
     &                    +sum2_pnefb(i,j,k)
c     Debug
c                     if ((i.eq.0).and.(k.eq.1176)) then
c                        write(*,*) i,j,k,sum_pnef(i,j)
c                     endif
c     Debug
                  enddo ! j
               enddo ! i
               do j=0,m
                  sum_faf(j)=sum_faf(j)+
     &                 sum_fafh(j,k)+sum_fafb(j,k)
                  sum_fdf(j)=sum_fdf(j)+
     &                 sum_fdfh(j,k)+sum_fdfb(j,k)
                  sum2_faf(j)=sum2_faf(j)+
     &                 sum2_fafh(j,k)+sum2_fafb(j,k)
                  sum2_fdf(j)=sum2_fdf(j)+
     &                 sum2_fdfh(j,k)+sum2_fdfb(j,k)
               enddo
            endif ! cpm
            
            do i=0,m+1
               sum_bil(i)=0.0D+0
               sum2_bil(i)=0.0D+0
               sum_bil_rev(i)=0.0D+0
               sum2_bil_rev(i)=0.0D+0
               sum_bil_gs(i)=0.0D+0
               sum_bil_ge(i)=0.0D+0
               sum_bil_gp(i)=0.0D+0
               sum_bil_gg(i)=0.0D+0
               sum2_bil_gs(i)=0.0D+0
               sum2_bil_ge(i)=0.0D+0
               sum2_bil_gp(i)=0.0D+0
               sum2_bil_gg(i)=0.0D+0
            enddo ! i
            sum_bil_se=0.0D+0
            sum2_bil_se=0.0D+0
            do i=0,m+1
               sum_bil(i)=sum_bilh(i,k)+sum_bilb(i,k)
               sum2_bil(i)=sum2_bilh(i,k)+sum2_bilb(i,k)
               sum_bil_rev(i)=sum_bil_rev_h(i,k)+sum_bil_rev_b(i,k)
               sum2_bil_rev(i)=sum2_bil_rev_h(i,k)+sum2_bil_rev_b(i,k)
               sum_bil_gs(i)=sum_bil_gs_h(i,k)+sum_bil_gs_b(i,k)
               sum_bil_ge(i)=sum_bil_ge_h(i,k)+sum_bil_ge_b(i,k)
               sum_bil_gg(i)=sum_bil_gg_h(i,k)+sum_bil_gg_b(i,k)
               sum_bil_gp(i)=sum_bil_gs(i)+sum_bil_ge(i)
               sum2_bil_gs(i)=sum2_bil_gs_h(i,k)+sum2_bil_gs_b(i,k)
               sum2_bil_ge(i)=sum2_bil_ge_h(i,k)+sum2_bil_ge_b(i,k)
               sum2_bil_gg(i)=sum2_bil_gg_h(i,k)+sum2_bil_gg_b(i,k)
               sum2_bil_gp(i)=sum2_bil_gs(i)+sum2_bil_ge(i)
            enddo ! i
c     Debug
c            write(*,*) 'sum_bil_rev(3)=',sum_bil_rev(3)
c     Debug
            sum_bil_se=sum_bil_se_h(k)+sum_bil_se_b(k)
            sum2_bil_se=sum2_bil_se_h(k)+sum2_bil_se_b(k)
            
            
            
c     Calcul des Termes Source (Bilan des mailles gazeuses)
            do i=0,m+1
               call statis(n_tir,sum_bil(i),sum2_bil(i),
     &              psi(i),var_psi(i),inc_psi(i)) ! direct method
               call statis(n_tir,sum_bil_rev(i),sum2_bil_rev(i),
     &              psi_rev(i),var_psi_rev(i),inc_psi_rev(i)) ! reverse method
               call statis(n_tir,sum_bil_gs(i),sum2_bil_gs(i),
     &              psi_gs(i),var_psi_gs(i),inc_psi_gs(i)) ! bilan gaz-sol
               call statis(n_tir,sum_bil_ge(i),sum2_bil_ge(i),
     &              psi_ge(i),var_psi_ge(i),inc_psi_ge(i)) ! bilan gaz-espace
               call statis(n_tir,sum_bil_gp(i),sum2_bil_gp(i),
     &              psi_gp(i),var_psi_gp(i),inc_psi_gp(i)) ! bilan gaz-paroi
               call statis(n_tir,sum_bil_gg(i),sum2_bil_gg(i),
     &              psi_gg(i),var_psi_gg(i),inc_psi_gg(i)) ! bilan gaz-gaz
            enddo
            call statis(n_tir,sum_bil_se,sum2_bil_se,
     &           psi_se,var_psi_se,inc_psi_se) ! change sol-espace
            
c     Normalisation en mW/m3/cm-1
            do i=0,m+1
               if ((i.eq.0).or.(i.eq.m+1)) then
                  tmp1=nbw
               else
                  tmp1=(e(i)-e(i-1))*nbw
               endif
               psi(i)=psi(i)/tmp1
               psi_rev(i)=psi_rev(i)/tmp1
               psi_gs(i)=psi_gs(i)/tmp1
               psi_ge(i)=psi_ge(i)/tmp1
               psi_gp(i)=psi_gp(i)/tmp1
               psi_gg(i)=psi_gg(i)/tmp1
               inc_psi(i)=inc_psi(i)/tmp1
               inc_psi_rev(i)=inc_psi_rev(i)/tmp1
               inc_psi_gs(i)=inc_psi_gs(i)/tmp1
               inc_psi_ge(i)=inc_psi_ge(i)/tmp1
               inc_psi_gp(i)=inc_psi_gp(i)/tmp1
               inc_psi_gg(i)=inc_psi_gg(i)/tmp1
            enddo

c     Recherche du meilleur bilan total par les 3 mthodes
c            do i=1,m
c               if (inc_psi(i).lt.inc_psi_rev(i)) then
c                  best_psi(i)=psi(i)
c                  inc_best_psi(i)=inc_psi(i)
c               else
c                  best_psi(i)=psi_rev(i)
c                  inc_best_psi(i)=inc_psi_rev(i)
c               endif
c               if (inc_best_psi(i).gt.
c     &              (inc_psi_gg(i)+inc_psi_gp(i))) then
c                  best_psi(i)=psi_gg(i)+psi_gp(i)
c                  inc_best_psi(i)=inc_psi_gg(i)+inc_psi_gp(i)
c               endif
c
c
c     Debug
c               write(*,52) psi(i),inc_psi(i),psi_rev(i),
c     &              inc_psi_rev(i),psi_gg(i)+psi_gp(i),
c     &              inc_psi_gg(i)+inc_psi_gp(i),best_psi(i),
c     &              inc_best_psi(i)
c     Debug
c
c            enddo

            do i=1,m
               best_psi(i)=psi(i)
               inc_best_psi(i)=inc_psi(i)
            enddo
            
c     Incrmentation des matrices de rsultats somms sur le spectre
            
            do i=0,m+1
               sum_tbil(i)=sum_tbil(i)+sum_bil(i)
               sum2_tbil(i)=sum2_tbil(i)+sum2_bil(i)
               sum_tbil_rev(i)=sum_tbil_rev(i)+sum_bil_rev(i)
               sum2_tbil_rev(i)=sum2_tbil_rev(i)+sum2_bil_rev(i)
            enddo

c     Calcul des bilans par bande en mW/m3/cm-1
            do i=0,m+1
               psib(i)=psib(i)+1.0D+3*best_psi(i)
               inc_psib(i)=inc_psib(i)+1.0D+3*inc_best_psi(i)
               psib_gg(i)=psib_gg(i)+1.0D+3*psi_gg(i)
               inc_psib_gg(i)=inc_psib_gg(i)+1.0D+3*inc_psi_gg(i)
               psib_gp(i)=psib_gp(i)+1.0D+3*psi_gp(i)
               inc_psib_gp(i)=inc_psib_gp(i)+1.0D+3*inc_psi_gp(i)
               psib_gs(i)=psib_gs(i)+1.0D+3*psi_gs(i)
               inc_psib_gs(i)=inc_psib_gs(i)+1.0D+3*inc_psi_gs(i)
               psib_ge(i)=psib_ge(i)+1.0D+3*psi_ge(i)
               inc_psib_ge(i)=inc_psib_ge(i)+1.0D+3*inc_psi_ge(i)
            enddo
            psi_seb=psi_seb+psi_se
            inc_psi_seb=inc_psi_seb+inc_psi_se
         enddo                  ! fin de boucle sur les quadratures

c     Calcul des PNE monochromatiques (par bande) 
c     et des flux nets  partir des PNE (par bande) si ncessaire
         if (cpm.eq.1) then
            do i=0,m+1
               do j=0,m+1
                  call statis(n_tir,sum_pnef(i,j),sum2_pnef(i,j),
     &                 pnef(i,j),var_pnef(i,j),inc_pnef(i,j))
c     Debug
c                  if ((i.eq.0).and.(j.eq.0)) then
c                     write(*,*) 'sum_pnef=',sum_pnef(i,j)
c                  endif
c                  write(*,*) 'pnef(',i,',',j,')=',pnef(i,j)
c     Debug
               enddo            ! sur j
            enddo               ! sur i
            do j=0,m
                  call statis(n_tir,sum_faf(j),sum2_faf(j),
     &                 faf(j),var_faf(j),inc_faf(j))
                  call statis(n_tir,sum_fdf(j),sum2_fdf(j),
     &                 fdf(j),var_fdf(j),inc_fdf(j))
            enddo               ! j
            call symetry(pnef,inc_pnef,pnefsym,inc_pnefsym)
            call Flux_nets_pne(pnefsym,inc_pnefsym,
     &     fnetb_pne,inc_fnetb_pne)
c     Recombinaison des PNE par bande
            call recombine_integrated_ner(m,pnef,mr,rpnef)
            call recombine_integrated_ner(m,inc_pnef,mr,inc_rpnef)
            call budget_from_ner(mr,rpnef,rpsib,
     &           rpsib_gs,rpsib_ge,rpsib_gg)
            call budget_from_ner(mr,inc_rpnef,inc_rpsib,
     &           inc_rpsib_gs,inc_rpsib_ge,inc_rpsib_gg)
c     normalisation en mW/m3/cm-1
            do i=0,mr+1
               if ((i.eq.0).or.(i.eq.mr+1)) then
                  tmp1=nbw
               else
                  tmp1=(er(i)-er(i-1))*nbw
               endif
               rpsib(i)=rpsib(i)/tmp1
               rpsib(i)=rpsib_gs(i)/tmp1
               rpsib(i)=rpsib_ge(i)/tmp1
               rpsib(i)=rpsib_gg(i)/tmp1
               inc_rpsib(i)=inc_rpsib(i)/tmp1
               inc_rpsib(i)=inc_rpsib_gs(i)/tmp1
               inc_rpsib(i)=inc_rpsib_ge(i)/tmp1
               inc_rpsib(i)=inc_rpsib_gg(i)/tmp1
            enddo
         endif

c     Normalisation en W/m/cm-1
         if (cpm.eq.1) then
c     computation of coefficients ksi
            call ksi_matrix(0,band,T0,pnef,ksi)
c     computation of coefficients ksi
            call ksi_matrix(1,band,rT0,rpnef,rksi)
            do i=0,m+1
               do j=0,m+1
                  pnef(i,j)=pnef(i,j)/nbw !  W/m/cm
                  inc_pnef(i,j)=inc_pnef(i,j)/nbw !  W/m/cm
               enddo ! sur j
            enddo ! sur i
            do i=0,mr+1
               do j=0,mr+1
                  rpnef(i,j)=rpnef(i,j)/nbw !  W/m/cm
                  inc_rpnef(i,j)=inc_rpnef(i,j)/nbw !  W/m/cm
               enddo ! sur j
            enddo ! sur i
            do i=0,m
               fnetb_pne(i)=fnetb_pne(i)/nbw !  W/m/cm
               inc_fnetb_pne(i)=inc_fnetb_pne(i)/nbw !  W/m/cm
               faf(i)=faf(i)/nbw !  W/m/cm
               fdf(i)=fdf(i)/nbw !  W/m/cm
               inc_faf(i)=inc_faf(i)/nbw !  W/m/cm
               inc_fdf(i)=inc_fdf(i)/nbw !  W/m/cm
            enddo               ! sur i
         endif
         
         if ((srf.eq.1).and.((band.ge.nb_min).and.
     &        (band.le.nb_max))) then
            write(10,50) (psib(i),i=1,m) ! mW/m
            write(11,50) (inc_psib(i),i=1,m)
            write(12,50) (psib_gg(i),i=1,m)
            write(13,50) (inc_psib_gg(i),i=1,m)
            write(14,50) (psib_gp(i),i=1,m)
            write(15,50) (inc_psib_gp(i),i=1,m)
            write(16,50) (psib_gs(i),i=1,m)
            write(17,50) (inc_psib_gs(i),i=1,m)
            write(18,50) (psib_ge(i),i=1,m)
            write(19,50) (inc_psib_ge(i),i=1,m)
            write(40,50) (rpsib(i),i=1,mr)
            write(41,50) (inc_rpsib(i),i=1,mr)
            write(42,50) (rpsib_gg(i),i=1,mr)
            write(43,50) (inc_rpsib_gg(i),i=1,mr)
            write(44,50) (rpsib_ge(i)+rpsib_gs(i),i=1,mr)
            write(45,50) (inc_rpsib_ge(i)+inc_rpsib_gs(i),i=1,mr)
            write(46,50) (rpsib_gs(i),i=1,mr)
            write(47,50) (inc_rpsib_gs(i),i=1,mr)
            write(48,50) (rpsib_ge(i),i=1,mr)
            write(49,50) (inc_rpsib_ge(i),i=1,mr)
            write(20,*) lambda_lo(band),lambda_hi(band),
     &           psi_seb,inc_psi_seb
            if (cpm.eq.1) then
               write(21,*) lambda_lo(band),lambda_hi(band)
               do i=0,m+1
                  write(21,50) (pnef(i,j),j=0,m+1)
                  write(21,50) (inc_pnef(i,j),j=0,m+1)
               enddo
               write(31,*) lambda_lo(band),lambda_hi(band)
               do i=0,mr+1
                  write(31,50) (rpnef(i,j),j=0,m+1)
                  write(31,50) (inc_rpnef(i,j),j=0,m+1)
               enddo
               write(22,*) lambda_lo(band),lambda_hi(band)
               write(22,50) (-fnetb_pne(i),i=0,m)
               write(22,50) (inc_fnetb_pne(i),i=0,m)
               write(22,50) (faf(i)-fdf(i),i=0,m)
               write(22,50) (inc_faf(i)+inc_fdf(i),i=0,m)

               write(24,*) lambda_lo(band),lambda_hi(band)
               write(24,50) (faf(i),i=0,m)
               write(24,50) (inc_faf(i),i=0,m)
               write(25,*) lambda_lo(band),lambda_hi(band)
               write(25,50) (fdf(i),i=0,m)
               write(25,50) (inc_fdf(i),i=0,m)

               write(34,50) lambda_lo(band),
     &              lambda_hi(band),
     &              faf(m)/faf(0),inc_faf(m)/faf(0),
     &              fdf(0)/faf(0),inc_fdf(0)/faf(0)

               write(23,*) lambda_lo(band),lambda_hi(band)
               do i=0,m+1
                  write(23,50) (ksi(i,j),j=0,m+1) ! [no unit]
               enddo
               write(33,*) lambda_lo(band),lambda_hi(band)
               do i=0,mr+1
                  write(33,50) (rksi(i,j),j=0,mr+1) ! [no unit]
               enddo
            endif
         endif                  ! fin sauvegarde rsultats frquentiels
         
      enddo                     ! fin boucle sur les bandes
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      close(18)
      close(19)
      close(20)
      close(21)
      close(22)
      close(23)
      close(24)
      close(25)
      close(31)
      close(33)
      close(34)
      close(40)
      close(44)
      close(42)
      close(43)
      close(44)
      close(45)
      close(46)
      close(47)
      close(48)
      close(49)

c     
c     +-----------------------------------------------------------------------------------+
c     |                    Calcul des rsultats somms sur le spectre                     |
c     +-----------------------------------------------------------------------------------+
c     
c     Calcul des Puissance Nettes Echanges non symtriques
      do i=0,m+1
         do j=0,m+1
            call statis(n_tir,sum_tpne(i,j),sum2_tpne(i,j),
     &           tPNE(i,j),var_tPNE(i,j),inc_tPNE(i,j))
         enddo
      enddo
      
c     Recombinaison des PNE non symtriques
      call recombine_integrated_ner(m,tPNE,mr,rtPNE)
      call recombine_integrated_ner(m,inc_tPNE,mr,inc_rtPNE)
      
c     Test de vrification de symtrie des PNE (aux barres d'erreur prs)
c
c     27/02/2004: je commente ce test pour imprimer moins de blabla  la
c     fin de l'excution (de toute faon la tableau des PNE est toujours
c     trs loin d'tre symtrique). Pour ractiver ce test, il suffit de
c     dcommenter les quelques lignes ci-dessous.
c
c      do i=0,m+1
c         do j=i,m+1
c            if (dabs(dabs(tPNE(i,j))-dabs(tPNE(j,i))).gt.
c     &           (inc_tPNE(i,j)+inc_tPNE(j,i))) then
c               call screen(1201,i,j,0.0D+0,0.0D+0)
c            endif
c         enddo
c      enddo

c     Symtrisation des Puissances Nettes Echanges
      call symetry(tPNE,inc_tPNE,tPNEsym,inc_tPNEsym)
c     Recombinaison des PNE symtriques
      call recombine_integrated_ner(m,tPNEsym,mr,rtPNEsym)
      call recombine_integrated_ner(m,inc_tPNEsym,mr,inc_rtPNEsym)
      

c     Calcul des flux nets intgrs fnett_pne  partir des PNE intgres
c     et symtrises
      call Flux_nets_pne(tPNEsym,inc_tPNEsym,
     &     fnett_pne,inc_fnett_pne)

c     Calcul des Termes Source (Bilan des mailles gazeuses)
      do i=0,m+1
         call statis(n_tir,sum_tbil(i),sum2_tbil(i),
     &        tpsi(i),var_tpsi(i),inc_tpsi(i))
         call statis(n_tir,sum_tbil_rev(i),sum2_tbil_rev(i),
     &        tpsi_rev(i),var_tpsi_rev(i),inc_tpsi_rev(i))

         if ((i.eq.0).or.(i.eq.m+1)) then
            tmp1=1.0D+0
         else
            tmp1=e(i)-e(i-1)
         endif
         tpsi(i)=tpsi(i)/tmp1
         inc_tpsi(i)=inc_tpsi(i)/tmp1
         tpsi_rev(i)=tpsi_rev(i)/tmp1
         inc_tpsi_rev(i)=inc_tpsi_rev(i)/tmp1
      enddo
c     calcul des bilans sur maillage recombin
      call budget_from_ner(mr,rtPNEsym,rtpsi,
     &     rtpsi_gs,rtpsi_ge,rtpsi_gg)
      call budget_from_ner(mr,inc_rtPNEsym,inc_rtpsi,
     &     inc_rtpsi_gs,inc_rtpsi_ge,inc_rtpsi_gg)


c --------------------------------
c     Dcomposition des bilans
c --------------------------------

c     Bilan parois-gaz
      do i=1,m
         tbil_pg(i)=tPNEsym(i,0)+tPNEsym(i,m+1)
         inc_tbil_pg(i)=inc_tPNEsym(i,0)+inc_tPNEsym(i,m+1)
      enddo
         
c     Bilans gaz-gaz
      do i=1,m
         sigmac=0.D+0
         sigmad2=0.D+0
         psic=0.D+0
         psid=0.D+0
          do j=1,m
             s1=inc_tPNE(i,j)
             s2=inc_tPNE(j,i)
             if (s1.lt.s2) then
                psic=psic+tPNE(i,j)
                sigmac=sigmac+s1
             else
                psid=psid-tPNE(j,i)
                sigmad2=sigmad2+s2**2
             endif
          enddo

          tbil_gg(i)=(psic+psid)
          inc_tbil_gg(i)=dsqrt(sigmac**2+sigmad2)
       enddo

c     En W/m3
      do i=1,m
         tbil_pg(i)=tbil_pg(i)/(e(i)-e(i-1))
         inc_tbil_pg(i)=inc_tbil_pg(i)/(e(i)-e(i-1))
         tbil_gg(i)=tbil_gg(i)/(e(i)-e(i-1))
         inc_tbil_gg(i)=inc_tbil_gg(i)/(e(i)-e(i-1))
      enddo

c     Recherche du meilleur des rsulats par les 3 mthodes de calcul
      do i=1,m
         if (inc_tpsi(i).lt.inc_tpsi_rev(i)) then
            best_bilan(i)=tpsi(i)
            inc_best_bilan(i)=inc_tpsi(i)
         else
            best_bilan(i)=tpsi_rev(i)
            inc_best_bilan(i)=inc_tpsi_rev(i)
         endif
         if ((inc_tbil_gg(i)+inc_tbil_pg(i)).lt.
     &        inc_best_bilan(i)) then
            best_bilan(i)=tbil_gg(i)+tbil_pg(i)
            inc_best_bilan(i)=inc_tbil_gg(i)+inc_tbil_pg(i)
         endif
      enddo
c     Temporairement j'impose les bilans indirects
      do i=1,m
         best_bilan(i)=tpsi(i)
         inc_best_bilan(i)=inc_tpsi(i)
      enddo


c     Calcul des Flux
c     fasc(i,j) et fdes(i,j) sont respectivement les flux
c     ascendants et descendants, mis de la maille i (0:m+1)
c     et traversant l'interface j (0:m).

      do i=0,m+1
         do j=0,m
            call statis(n_tir,sum_fasc(i,j),sum2_fasc(i,j),
     &           fasc(i,j),var_fasc(i,j),inc_fasc(i,j))

            call statis(n_tir,sum_fdes(i,j),sum2_fdes(i,j),
     &           fdes(i,j),var_fdes(i,j),inc_fdes(i,j))
         enddo
      enddo

      do i=0,m
         do sec=1,Nsec
            call statis(n_tir,sum_fa_ang(i,sec),sum2_fa_ang(i,sec),
     &           fa_ang(i,sec),var_fa_ang(i,sec),inc_fa_ang(i,sec))
            call statis(n_tir,sum_fd_ang(i,sec),sum2_fd_ang(i,sec),
     &           fd_ang(i,sec),var_fd_ang(i,sec),inc_fd_ang(i,sec))
         enddo
      enddo

c     Debug
c      write(*,*) 'fasc(0,0)=',fasc(0,0)
c     Debug

c     fasct et fdest sont respectivement les flux
c     ascendants et descendants totaux traversant l'interface j (0:m)

      do j=0,m
         fasct(j)=0.0D+0
         fdest(j)=0.0D+0
         inc_fasct(j)=0.0D+0
         inc_fdest(j)=0.0D+0
         do i=0,m+1
            fasct(j)=fasct(j)+fasc(i,j)
            fdest(j)=fdest(j)+fdes(i,j)
            inc_fasct(j)=inc_fasct(j)+inc_fasc(i,j)
            inc_fdest(j)=inc_fdest(j)+inc_fdes(i,j)
         enddo
         fnett(j)=fasct(j)-fdest(j)
         inc_fnett(j)=inc_fasct(j)+inc_fdest(j)
      enddo
c     Debug
c      write(*,*) 'fdest(',m,')=',fdest(m)
c      do i=0,m+1
c         write(*,*) 'fdes(',i,')=',fdes(i,m)
c      enddo
c     Debug

c     Debug
c      do i=1,m
c         write(*,50) (e(i)+e(i-1))/2.0D+0,
c     &        tpsi(i)*(e(i)-e(i-1)),
c     &        tpsi_rev(i)*(e(i)-e(i-1)),
c     &        fnett(i-1)-fnett(i),
c     &        (tbil_gg(i)+tbil_pg(i))*(e(i)-e(i-1))
c      enddo
c     Debug
         

c     fini

c --------------------------------
c     Dcomposition des bilans
c --------------------------------
       
      

c
c     +-----------------------------------------------------------------------------------+
c     |                           Sauvegarde des rsultats                                |
c     +-----------------------------------------------------------------------------------+
c
c
c     Sauvegarde des PNE, PNE symtriques et Cooling Rates
      open(10,file=file_pne)
      open(11,file=file_pnesym)
      open(12,file=file_CR)
      open(13,file='./results/rPNE.txt')
      open(14,file='./results/rPNEsym.txt')
      do i=0,m+1
         do j=0,m+1
            write(10,*) tPNE(i,j),inc_tPNE(i,j)
            write(11,*) tPNEsym(i,j),inc_tPNEsym(i,j)
            if ((i.eq.0).or.(i.eq.m+1)) then
               write(12,*) 0.0D+0,0.0D+0
            else
               write(12,*) tPNEsym(i,j)*d_t/dQe(i),
     &              inc_tPNEsym(i,j)*d_t/dQe(i)
            endif
         enddo
      enddo
      do i=0,mr+1
         do j=0,mr+1
            write(13,*) rtPNE(i,j),inc_rtPNE(i,j)
            write(14,*) rtPNEsym(i,j),inc_rtPNEsym(i,j)
         enddo
      enddo
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)

c     Sauvegarde des Termes Source
      open(10,file=file_tsource)
      do i=1,m
         z=(e(i)+e(i-1))/2.0D+0
c     Warning ! Bilan sauv en mW/m3, altitude sauve en km

c     Commentaires sur le fichier de sauvegarde des bilans
c
c     Par colonne : (* : dsactiv)
c       + 1 - z en km
c       + * - bilan total calcul par mthode directe en mW/m3
c       + * - incertitude en mW/m3
c       + * - bilan total calcul par mthode inverse en mW/m3
c       + * - incertitude en mW/m3
c       + 2 - bilan gaz-gaz calcul par PNE en mW/m3
c       + 3 - incertitude en mW/m3
c       + 4 - bilan paroi-gaz calcul par PNE en mW/m3
c       + 5 - incertitude en mW/m3
c       + * - bilan total calcul par PNE en mW/m3
c       + * - incertitude en mW/m3
c       + 6 - meilleur bilan des 3 mthodes en mW/m3
c       + 7 - incertitude en mW/m3
c       + 8 - Cooling rate en K/day
c       + 9 - incertitude en K/day
c

         write(10,55) z/1.0D+3,
c     &        tpsi(i)*1.0D+3,inc_tpsi(i)*1.0D+3,
c     &        tpsi_rev(i)*1.0D+3,inc_tpsi_rev(i)*1.0D+3,
     &        tbil_gg(i)*1.0D+3,inc_tbil_gg(i)*1.0D+3,
     &        tbil_pg(i)*1.0D+3,inc_tbil_pg(i)*1.0D+3,
c     &        (tbil_gg(i)+tbil_pg(i))/(e(i)-e(i-1))*1.0D+3,
c     &        (inc_tbil_gg(i)+inc_tbil_pg(i))/(e(i)-e(i-1))*1.0D+3,
     &        best_bilan(i)*1.0D+3,inc_best_bilan(i)*1.0D+3,
     &        best_bilan(i)*d_t/dQe(i),
     &        inc_best_bilan(i)*d_t/dQe(i)

      enddo
      close(10)

c     Sauvegarde des bilans recombins
      open(10,file='./results/rTsource.txt')
      do i=1,mr
         z=(er(i)+er(i-1))/2.0D+3 ! km
         write(10,55) z, ! km
     &        rtpsi_gg(i)/(er(i)-er(i-1))*1.0D+3, ! mW/m
     &        inc_rtpsi_gg(i)/(er(i)-er(i-1))*1.0D+3, ! mW/m
     &        (rtpsi_gs(i)+rtpsi_ge(i))/(er(i)-er(i-1))*1.0D+3, ! mW/m
     &        (inc_rtpsi_gs(i)+inc_rtpsi_ge(i))/(er(i)-er(i-1))*1.0D+3, ! mW/m
     &        rtpsi(i)/(er(i)-er(i-1))*1.0D+3, ! mW/m
     &        inc_rtpsi(i)/(er(i)-er(i-1))*1.0D+3 ! mW/m
      enddo
      close(10)

c     Pour vrifier que les bilans calculs par les diffrentes
c     mthodes ont bien les mmes valeurs numriques...
c     Debug
      open(11,file='./results/Tsource2.txt')
      do i=1,m
         write(11,50) tpsi(i),inc_tpsi(i),
     &        tpsi_rev(i),inc_tpsi_rev(i),
     &        tbil_pg(i)+tbil_gg(i),inc_tbil_pg(i)+inc_tbil_gg(i)
      enddo
      close(11)
c     Debug

c     Sauvegarde des flux
      open(10,file=file_flux_ascendants)
      open(11,file=file_flux_descendants)
      open(12,file=file_flux_ascendants_totaux)
      open(13,file=file_flux_descendants_totaux)
      open(14,file='./results/Flux_nets_int.txt')
      open(15,file='./results/Flux_asc_int_ang.txt')
      open(16,file='./results/Flux_des_int_ang.txt')
      open(17,file='./results/angular_transmittivity.txt')
      open(18,file='./results/angular_reflectivity.txt')
      open(19,file='./results/total_transm_refl.txt')
      write(17,*) m+1,Nsec
      write(18,*) m+1,Nsec
      write(19,*) m+1,Nsec
      do j=0,m
         write(10,50) (fasc(i,j),i=0,m+1)
         write(10,50) (inc_fasc(i,j),i=0,m+1)
         write(11,50) (fdes(i,j),i=0,m+1)
         write(11,50) (inc_fdes(i,j),i=0,m+1)
         write(12,*) e(j)/1.0D+3,fasct(j),inc_fasct(j)
         write(13,*) e(j)/1.0D+3,fdest(j),inc_fdest(j)
         write(14,50) e(j)/1.0D+3,fnett(j),inc_fnett(j),
     &        -fnett_pne(j),inc_fnett_pne(j)
         write(15,*) 'Interface ',j,' /',m,' z=',e(j)
         write(16,*) 'Interface ',j,' /',m,' z=',e(j)
c     Debug
c         fat_ang(j)=0.0D+0
c         fdt_ang(j)=0.0D+0
c     Debug
         do sec=Nsec/2+1,Nsec
            write(15,*) theta_sec(sec,1),
     &           theta_sec(sec,2),
     &           fa_ang(j,sec)/2.0D+0,
     &           inc_fa_ang(j,sec)/2.0D+0
         enddo                  ! sec
         do sec=Nsec,Nsec/2+1,-1
            write(15,*) 2.0D+0*pi-theta_sec(sec,2),
     &           2.0D+0*pi-theta_sec(sec,1),
     &           fa_ang(j,sec)/2.0D+0,
     &           inc_fa_ang(j,sec)/2.0D+0
         enddo                  ! sec
         do sec=Nsec/2,1,-1
            write(16,*) 2.0D+0*pi-theta_sec(sec,2),
     &           2.0D+0*pi-theta_sec(sec,1),
     &           fd_ang(j,sec)/2.0D+0,
     &           inc_fd_ang(j,sec)/2.0D+0
         enddo                  ! sec
         do sec=1,Nsec/2
            write(16,*)  theta_sec(sec,1),
     &           theta_sec(sec,2),
     &           fd_ang(j,sec)/2.0D+0,
     &           inc_fd_ang(j,sec)/2.0D+0
c     Debug
c            fat_ang(j)=fat_ang(j)+fa_ang(j,sec)
c            fdt_ang(j)=fdt_ang(j)+fd_ang(j,sec)
c     Debug
         enddo                  ! sec
c     Debug
c         write(*,*) 'fat_ang(',j,')=',fat_ang(j),
c     &        ' fdt_ang(',j,')=',fdt_ang(j)
c     Debug
         write(17,*) 'Interface ',j,' /',m,' z=',e(j)
         write(18,*) 'Interface ',j,' /',m,' z=',e(j)
         do sec=Nsec/2+1,Nsec
            write(17,50) theta_sec(sec,1),
     &           theta_sec(sec,2),
     &           fa_ang(j,sec)/(2.0D+0*fasct(0)),
     &           inc_fa_ang(j,sec)/(2.0D+0*fasct(0))
         enddo                  !sec
         do sec=Nsec,Nsec/2+1,-1
            write(17,50) 2.0D+0*pi-theta_sec(sec,2),
     &           2.0D+0*pi-theta_sec(sec,1),
     &           fa_ang(j,sec)/(2.0D+0*fasct(0)),
     &           inc_fa_ang(j,sec)/(2.0D+0*fasct(0))
         enddo ! sec            ! sec
         do sec=Nsec/2,1,-1
            write(18,50) 2.0D+0*pi-theta_sec(sec,2),
     &           2.0D+0*pi-theta_sec(sec,1),
     &           fd_ang(j,sec)/(2.0D+0*fasct(0)),
     &           inc_fd_ang(j,sec)/(2.0D+0*fasct(0))
         enddo                  ! sec
         do sec=1,Nsec/2
            write(18,50) theta_sec(sec,1),
     &           theta_sec(sec,2),
     &           fd_ang(j,sec)/(2.0D+0*fasct(0)),
     &           inc_fd_ang(j,sec)/(2.0D+0*fasct(0))
         enddo      
      enddo                     ! j
      write(19,50) fasct(m)/fasct(0),
     &     inc_fasct(m)/fasct(0),
     &     fdest(0)/fasct(0),
     &     inc_fdest(0)/fasct(0)
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      close(18)
      close(19)

      return
      end



      subroutine make_tics(Nelem,xvalues,marks,nap,tics_str)
      implicit none
      include 'max.inc'
c
c     Purpose: to produce a tics string for gnuplot labeling
c
c     Input:
c       + Nelem: number of elements
c       + xvalues: the "Nelem" values of the variable
c       + marks: the corresponding "Nelem" values that must be displayed (instead of the values of the variable)
c       + nap: number of digits after the decimal separator that must be printed
c     
c     Output:
c       + tics_str: tics string
c
c     I/O
      integer Nelem
      double precision xvalues(1:Nelem_mx)
      double precision marks(1:Nelem_mx)
      integer nap
      character*(Nchar_mx) tics_str
c     temp
      integer i
      integer conv_err
      character*(Nchar_mx) dble_str
c     label
      integer strlen
      character*(Nchar_mx) label
      label='subroutine make_tics'

      if (Nelem.gt.Nelem_mx) then
         call error(label)
         write(*,*) 'Nelem=',Nelem
         write(*,*) 'while Nelem_mx=',Nelem_mx
         stop
      endif
      if (nap.lt.0) then
         call error(label)
         write(*,*) 'nap=',nap
         stop
      endif

      tics_str='('

      do i=1,Nelem
         call dble2str_noexp(marks(i),nap,dble_str,conv_err)
         if (conv_err.ne.0) then
            call error(label)
            write(*,*) 'could not convert to character string:'
            write(*,*) 'marks(',i,')=',marks(i)
            stop
         else
            tics_str=tics_str(1:strlen(tics_str))
     &           //'"'
     &           //dble_str(1:strlen(dble_str))
     &           //'" '
         endif
         call dble2str_noexp(xvalues(i),nap,dble_str,conv_err)
         if (conv_err.ne.0) then
            call error(label)
            write(*,*) 'could not convert to character string:'
            write(*,*) 'xvalues(',i,')=',xvalues(i)
            stop
         else
            tics_str=tics_str(1:strlen(tics_str))
     &           //' '
     &           //dble_str(1:strlen(dble_str))
         endif
         if (i.lt.Nelem) then
            tics_str=tics_str(1:strlen(tics_str))
     &           //', '
         endif
         if (strlen(tics_str).ge.Nchar_mx) then
            call error(label)
            write(*,*) 'tics_str exceeds maximum length'
            stop
         endif
      enddo ! i

      tics_str=tics_str(1:strlen(tics_str))
     &     //')'

      return
      end
