c     Copyright (C)
c     2000 -2013 Universite Paul Sabatier,
c     2000 -2013 Centre National de la Recherche Scientifique
c     2000 -2013 Ecole des Mines d'Albi
c     2014-2018 Msostar
c
c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine sauvegarde(Nb,Nq,band,quad,md,paq)
c
c     Sauvegarde des rsultats intermdiaires dans le cas
c     o un calcul serait malhontement interrompu
c
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'
      include 'files_out.inc'
      include 'tab.inc'
      include 'formats.inc'
      integer md,paq,i,j,q,n_max,nk,sec
      integer iseed,md_sav,paq_sav
      integer date,strlen
      character*100 name1,name2,arrays1,arrays2
      common/comsee/iseed
      integer Nb,Nq,band,quad,out
      nk=Kmax

c     Les valeurs de md et paq corresondent au dernier rayon pour lequel
c     le calcul a t effectu. Je veux sauvegarder les valeurs de md et paq
c     a partir desquelles on doit reprendre le calcul en cas d'interruption.

      arrays1='./temporary/arrays1.sav'
      arrays2='./temporary/arrays2.sav'

      paq_sav=paq
      md_sav=md
      paq_sav=paq_sav+1
      call calc_nmax(md,n_max)
      if (paq_sav.gt.n_max) then
         paq_sav=1
         md_sav=md_sav+1
      endif

      open(10,file='./temporary/sauvegarde.txt')
      read(10,53) name1
c     'name1' est le nom du fichier ('arrays1.sav' ou 'arrays2.sav') dans lequel
c     on a sauvegard avec succs l'tat du calcul le plus rcent
      close(10)

      if (name1(1:strlen(name1)).eq.
     &     '"'//arrays1(1:strlen(arrays1))//'"') then
         name2=arrays2
      else
         name2=arrays1
      endif
c     'name2' est donc le nom du fichier dans lequel on va maintenant sauvegarder
c     l'tat du calcul

      call cur_date(date)

c     Ensuite il n'y a plus qu' sauvegarder l'tat du calcul
      open(11,file=name2(1:strlen(name2)))
      write(11,*) md_sav,paq_sav
      write(11,*) date
      do i=0,m+1
         do j=0,m+1
            write(11,*) sum_pneh(i,j)
            write(11,*) sum2_pneh(i,j)
            write(11,*) sum_pneb(i,j)
            write(11,*) sum2_pneb(i,j)
            write(11,*) sum_fasch(i,j)
            write(11,*) sum2_fasch(i,j)
            write(11,*) sum_fdesh(i,j)
            write(11,*) sum2_fdesh(i,j)
            write(11,*) sum_fascb(i,j)
            write(11,*) sum2_fascb(i,j)
            write(11,*) sum_fdesb(i,j)
            write(11,*) sum2_fdesb(i,j)
         enddo
      enddo
      do i=0,m
         do sec=1,Nsec
            write(11,*) sum_fah_ang(i,sec)
            write(11,*) sum2_fah_ang(i,sec)
            write(11,*) sum_fdh_ang(i,sec)
            write(11,*) sum2_fdh_ang(i,sec)
            write(11,*) sum_fab_ang(i,sec)
            write(11,*) sum2_fab_ang(i,sec)
            write(11,*) sum_fdb_ang(i,sec)
            write(11,*) sum2_fdb_ang(i,sec)
         enddo
      enddo
      do q=1,Nb*Nq
         do i=0,m+1
            write(11,*) sum_bilh(i,q)
            write(11,*) sum2_bilh(i,q)
            write(11,*) sum_bilb(i,q)
            write(11,*) sum2_bilb(i,q)
            write(11,*) sum_bil_rev_h(i,q)
            write(11,*) sum2_bil_rev_h(i,q)
            write(11,*) sum_bil_rev_b(i,q)
            write(11,*) sum2_bil_rev_b(i,q)
            write(11,*) sum_bil_gs_h(i,q)
            write(11,*) sum_bil_ge_h(i,q)
            write(11,*) sum_bil_gg_h(i,q)
            write(11,*) sum2_bil_gs_h(i,q)
            write(11,*) sum2_bil_ge_h(i,q)
            write(11,*) sum2_bil_gg_h(i,q)
            write(11,*) sum_bil_gs_b(i,q)
            write(11,*) sum_bil_ge_b(i,q)
            write(11,*) sum_bil_gg_b(i,q)
            write(11,*) sum2_bil_gs_b(i,q)
            write(11,*) sum2_bil_ge_b(i,q)
            write(11,*) sum2_bil_gg_b(i,q)
         enddo
         do j=0,m
            write(11,*) sum_fafh(j,q)
            write(11,*) sum_fdfh(j,q)
            write(11,*) sum_fafb(j,q)
            write(11,*) sum_fdfb(j,q)
            write(11,*) sum2_fafh(j,q)
            write(11,*) sum2_fdfh(j,q)
            write(11,*) sum2_fafb(j,q)
            write(11,*) sum2_fdfb(j,q)
         enddo
      enddo
      close(11)
      
      out=1
      call countd(2,0,0,0.0D+0,out)
      seed0=iseed
      call write_seed0()

c     On crit finalement dans le fichier 'sauvegarde.txt' le nom du fichier
c     dans lequel on vient de sauvegarder l'tat du calcul. Cette tape
c     vient en dernier pour les cas o le programme serait interrompu
c     pendant l'tape de sauvegarde ci-dessus, cas dans lequel l'tat du calcul
c     ne serait pas sauvegard avec succs, et o il faudra aller chercher, la
c     prochaine fois que le programme sera relanc, l'tat du calcul dans le
c     fichier 'name1' qui sera encore le dernier fichier o l'tat du calcul
c     a t sauvegard en entier avec succs.
      open(10,file='./temporary/sauvegarde.txt')
      write(10,53) '"'//name2(1:strlen(name2))//'"'
      close(10)
c     Je suppose donc ici que le programme ne peut pas tre interrompu pendant
c     l'opration d'criture de 'name2' dans 'sauvegarde.txt'
c     (sous-entendu tape rapide)
      
      return
      end
